> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.beehiiv.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.beehiiv.com/_mcp/server.

# Update webhook <Badge intent="info" minimal outlined>OAuth Scope: webhooks:write</Badge>

PATCH https://api.beehiiv.com/v2/publications/{publicationId}/webhooks/{endpointId}
Content-Type: application/json

Update a webhook subscription for a publication.

Reference: https://developers.beehiiv.com/api-reference/webhooks/update

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `publicationId` (string, required) — The prefixed ID of the publication object
- `endpointId` (string, required) — The prefixed ID of the webhook object

### Body (application/json)

This endpoint expects an object.

- `event_types` (list of enum, optional) — The types of events the webhook will receive.
  - Allowed values: `post.sent`, `post.updated`, `subscription.confirmed`, `subscription.created`, `subscription.downgraded`, `subscription.paused`, `subscription.resumed`, `subscription.tier.paused`, `subscription.tier.resumed`, `subscription.upgraded`, `subscription.tier.created`, `subscription.tier.deleted`, `subscription.deleted`, `newsletter_list_subscription.subscribed`, `newsletter_list_subscription.unsubscribed`, `newsletter_list_subscription.paused`, `newsletter_list_subscription.resumed`, `post.scheduled`, `survey.response_submitted`, `podcasts.episode.published`, `podcasts.episode.updated`, `podcasts.episode.archived`, `podcasts.episode.deleted`, `podcasts.private_feed.activated`, `podcasts.private_feed.access_revoked`, `podcasts.private_feed.deactivated`
- `description` (string, optional) — A description of the webhook.

## Response

### 200

OK

- `data` (Webhook, required)

## Errors

### 400 Bad Request Error

Bad Request

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 401 Unauthorized Error

Unauthorized. The API key or OAuth access token is missing, invalid, or expired.

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 404 Not Found Error

Resource Not Found

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 429 Too Many Requests Error

Rate Limit Exceeded

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 500 Internal Server Error

Internal Server Error

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

## Types

### Webhook

- `id` (string, required) — The prefixed ID for the webhook.
- `url` (string, required) — The webhook URL to send events to.
- `created` (integer, required) — The date the webhook was created. Measured in seconds since the Unix epoch.
- `updated` (integer, required) — The date the webhook was last updated. Measured in seconds since the Unix epoch.
- `event_types` (list of enum, required) — The types of events the webhook will receive.
  - Allowed values: `post.sent`, `post.updated`, `subscription.confirmed`, `subscription.created`, `subscription.downgraded`, `subscription.paused`, `subscription.resumed`, `subscription.tier.paused`, `subscription.tier.resumed`, `subscription.upgraded`, `subscription.tier.created`, `subscription.tier.deleted`, `subscription.deleted`, `newsletter_list_subscription.subscribed`, `newsletter_list_subscription.unsubscribed`, `newsletter_list_subscription.paused`, `newsletter_list_subscription.resumed`, `post.scheduled`, `survey.response_submitted`, `podcasts.episode.published`, `podcasts.episode.updated`, `podcasts.episode.archived`, `podcasts.episode.deleted`, `podcasts.private_feed.activated`, `podcasts.private_feed.access_revoked`, `podcasts.private_feed.deactivated`
- `description` (string, required) — The user-defined description for the webhook.

### ErrorDetail

- `message` (string, required)
- `code` (string, required)

## Examples

**Request**

```json
{
  "event_types": [
    "post.sent",
    "subscription.confirmed"
  ],
  "description": "A webhook to receive new posts data and new subscription confirmations."
}
```

**Response**

```json
{
  "data": {
    "id": "ep_0ca1a8505a64924059c391744d0",
    "url": "https://example.com/webhook",
    "created": 1666800076,
    "updated": 1666800076,
    "event_types": [
      "post.sent",
      "subscription.confirmed"
    ],
    "description": "A webhook to receive new posts data and new subscription confirmations."
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/webhooks/ep_0000000000000000000000000000"

payload = {
    "event_types": ["post.sent", "subscription.confirmed"],
    "description": "A webhook to receive new posts data and new subscription confirmations."
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/webhooks/ep_0000000000000000000000000000';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"event_types":["post.sent","subscription.confirmed"],"description":"A webhook to receive new posts data and new subscription confirmations."}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/webhooks/ep_0000000000000000000000000000"

	payload := strings.NewReader("{\n  \"event_types\": [\n    \"post.sent\",\n    \"subscription.confirmed\"\n  ],\n  \"description\": \"A webhook to receive new posts data and new subscription confirmations.\"\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/webhooks/ep_0000000000000000000000000000")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"event_types\": [\n    \"post.sent\",\n    \"subscription.confirmed\"\n  ],\n  \"description\": \"A webhook to receive new posts data and new subscription confirmations.\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/webhooks/ep_0000000000000000000000000000")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"event_types\": [\n    \"post.sent\",\n    \"subscription.confirmed\"\n  ],\n  \"description\": \"A webhook to receive new posts data and new subscription confirmations.\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/webhooks/ep_0000000000000000000000000000', [
  'body' => '{
  "event_types": [
    "post.sent",
    "subscription.confirmed"
  ],
  "description": "A webhook to receive new posts data and new subscription confirmations."
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/webhooks/ep_0000000000000000000000000000");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"event_types\": [\n    \"post.sent\",\n    \"subscription.confirmed\"\n  ],\n  \"description\": \"A webhook to receive new posts data and new subscription confirmations.\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "event_types": ["post.sent", "subscription.confirmed"],
  "description": "A webhook to receive new posts data and new subscription confirmations."
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/webhooks/ep_0000000000000000000000000000")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```